;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;     Vertical Flip
;          By
;      Greg Harder
;================================
ORG 4084

@DFILE=400C		;Start of D-FILE
@VARS=4010		;
@PRBUFF=403C		;Line storage

@LINE1
	00 00		;Address of LINE1
@LINE2
	00 00		;Address of LINE2
@VFLIP
	LD HL,(DFILE)	;Start of DFILE
	INC HL		;
	LD (LINE1),HL	;Save LINE1 addr
	LD BC,0021	;Calculate
	LD HL,(VARS)	;address
	XOR A		;of
	SBC HL,BC	;LINE2
	LD B,0C		;Rows to process counter
@VF01
	PUSH BC		;PUSH counter
	LD (LINE2),HL	;Save LINE2 addr
	LD HL,(LINE1)	;Transfer
	LD DE,PRBUFF	;LINE1 data
	LD BC,0020	;to
	LDIR		;storage area

	LD HL,(LINE1)	;Transfer
	EX DE,HL	;LINE2
	LD HL,(LINE2)	;data
	LD C,20		;to
	LDIR		;LINE1 address
	INC DE		;Start of next LINE1
	LD (LINE1),DE	;Save LINE1

	LD HL,PRBUFF	;Transfer
	LD DE,(LINE2)	;LINE1 data
	LD C,20		;to
	LDIR		;LINE2 address

	LD C,21		;Calculate 
	LD HL,(LINE2)	;address
	XOR A		;of
	SBC HL,BC	;next LINE2
	POP BC		;POP row counter
	DJNZ VF01	;Repeat if NZ
;================================
;This section properly "flips"
;the pixel/graphic characters.
;================================
	LD HL,(DFILE)
	LD BC,0318	;Counter=792=DFILE size
@VF02
	PUSH BC
	INC HL
	LD A,(HL)	;Get character
	BIT 7,A		;Character code>=128?
	JR Z VF03	;No
	SUB 80
	LD DE,VTABLE2	;Use VTABLE2 for codes>=128
	JR VF04		
@VF03
	LD DE,VTABLE1	;Use VTABLE1 for codes<=63
@VF04
	AND A		;The code 0 doesn't
	JR Z VF06	;need to be flipped
	LD B,00		;Test
	LD C,A		;for
	SUB 0B		;Valid pixel code?
	JR NC VF06	;IF A>10 THEN not a valid pixel
@VF05
	EX DE,HL	;HL=Table
	ADD HL,BC	;Add offset to table
	LD A,(HL)	;A=Flipped pixel character
	EX DE,HL	;HL=DFILE addr
	LD (HL),A	;Print flipped character
@VF06
	POP BC		;POP counter
	DEC BC		;Decrease counter
	LD A,B 
	OR C
	JR NZ VF02	;IF NZ THEN GOTO VF02
	RET

@VTABLE1
	00 04 87 83 01 05 86 82 88 0A 09
@VTABLE2
	80 84 07 03 81 85 06 02 08 8A 89
	
